Subject: Re: bug#54811: [PATCH 0/3] Support socket activation in 'guix publish' and 'guix-daemon'

From: Ludovic Courtès <[email-masked]>
Date: Tue, 12 Apr 2022 12:15:14 +0200

Maxime Devos <[email-masked]> skribis:

> Ludovic Courtès schreef op ma 11-04-2022 om 22:33 [+0200]:
>> > Alternatively, the shepherd could open the secret key file on
>> > behalf of
>> > ‘guix publish’ and send it together with the listening socket to
>> > ‘guix
>> > publish’.
>> 
>> Sure, that’s feasible, but that’d require a custom protocol that I’d
>> rather avoid.
>
> I don't think it does, as long as we are using Shepherd and not SystemD
> (I don't think that SystemD supports opening regular files instead of
> sockets?), we could just 
>
>   * extend 'endpoint->listening-socket' (in Shepherd) to allow opening
>     regular files (and not only actual sockets)
>   * in 'systemd-socket' (in (guix scripts publish)), expect two startup
>     file descriptors instead of one startup file descriptor, and return
>     both (the first one is the actual listening socket, the second one
>     the secret key file)

We could, but like I wrote, I’d rather stick to the existing systemd (or
inetd) protocol, especially since this extension wouldn’t buy us much IMO.

Ludo’.